'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _PropTypes = require('../../PropTypes');

var _Axis = require('./Axis');

var _Axis2 = _interopRequireDefault(_Axis);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * This file is part of the nivo project.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright 2016-present, Raphaël Benitte.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * For the full copyright and license information, please view the LICENSE
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * file that was distributed with this source code.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var horizontalPositions = ['top', 'bottom'];
var verticalPositions = ['left', 'right'];
var positions = [].concat(horizontalPositions, verticalPositions);

var axisPropType = _propTypes2.default.shape({
    tickSize: _propTypes2.default.number,
    tickPadding: _propTypes2.default.number,
    format: _propTypes2.default.func
});

var Axes = function (_Component) {
    _inherits(Axes, _Component);

    function Axes() {
        _classCallCheck(this, Axes);

        return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    Axes.prototype.render = function render() {
        var _props = this.props,
            xScale = _props.xScale,
            yScale = _props.yScale,
            width = _props.width,
            height = _props.height,
            axes = _props.axes,
            theme = _props.theme,
            animate = _props.animate,
            motionStiffness = _props.motionStiffness,
            motionDamping = _props.motionDamping;


        return _react2.default.createElement(
            'g',
            null,
            positions.map(function (position) {
                if (!axes[position]) return null;

                var axis = axes[position];
                if (axis.enabled !== undefined && axis.enabled === false) return null;

                var scale = horizontalPositions.includes(position) ? xScale : yScale;

                return _react2.default.createElement(_Axis2.default, _extends({
                    theme: theme
                }, axis, {
                    key: position,
                    width: width,
                    height: height,
                    position: position,
                    scale: scale,
                    animate: animate,
                    motionDamping: motionDamping,
                    motionStiffness: motionStiffness
                }));
            })
        );
    };

    return Axes;
}(_react.Component);

Axes.propTypes = _extends({
    xScale: _propTypes2.default.func.isRequired,
    yScale: _propTypes2.default.func.isRequired,

    width: _propTypes2.default.number.isRequired,
    height: _propTypes2.default.number.isRequired,

    axes: _propTypes2.default.shape({
        top: axisPropType,
        right: axisPropType,
        bottom: axisPropType,
        left: axisPropType
    }).isRequired,

    theme: _propTypes2.default.object.isRequired

}, _PropTypes.motion);
Axes.defaultProps = {};
exports.default = Axes;